# !Bulgarian! -*-codeset: iso-8859-5;-*-
#
#   This file is automaticaly generated. 
#   It is a part of the Debian bulgarian-env package.
#   Language Support File for Bulgarian
#
# Copyright (C) 1998-2000 Tomohiro KUBOTA
# Copyright (C) 2000 Peter Novodvorsky
# Copyright (C) 2000 Anton Zinoviev
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# On Debian GNU/Linux systems, the complete text of the GNU General
# Public License can be found in `/usr/share/common-licenses/GPL'.


# ---------------------------------------------------
# isNC()
# ---------------------------------------------------
sub isNC($$$) {
    my ($TTY, $TERM, $DISPLAY, $HOME, $THIS, $OPT, $OPT_N, $FONT);
    $TTY = `/usr/bin/tty`;
    $TERM = $ENV{TERM};
    $DISPLAY = $ENV{DISPLAY};
    $HOME = $ENV{HOME};
    $THIS = $_[0];
    $OPT = $_[1];
    $OPT_N = $_[2];
    
    if ($ENV{HAVE_CYR} ne '') {
	return 1;
    }
    if ($DISPLAY ne '' && !$OPT_N && ($FONT = &havecyrfont)) {
	my ($TITLE, $BGC, $FGC);
	$TITLE = &terminal_name();
	$BGC = "lightgrey";
	$FGC = "grey30";
	if (&executable("rxvt")) {
	    exec("HAVE_CYR=1; export HAVE_CYR; ".
		 "rxvt -fn '$FONT' -bg ${BGC} -fg ${FGC} -title '${TITLE}' ".
		 "-e $THIS -N -C $OPT");
	}
	if (&executable("xvt")) {
	    exec("HAVE_CYR=1; export HAVE_CYR; ".
		 "xvt -fn '$FONT' -bg ${BGC} -fg ${FGC} -title '${TITLE}' ".
		 "-e $THIS -N -C $OPT");
	}
	if (&executable("xterm")) {
	    exec("HAVE_CYR=1; export HAVE_CYR; ".
		 "xterm -fn '$FONT' -bg ${BGC} -fg ${FGC} -title '${TITLE}' ".
		 "-e $THIS -N -C $OPT");
	}
	if (&executable("Eterm")) {
	    exec("HAVE_CYR=1; export HAVE_CYR; ".
		 "Eterm --title '${TITLE}' -F '$FONT' -e $THIS -N -C $OPT");
	}
    }
    elsif (($TTY =~ m!/dev/tty[0-9]+! || $TTY =~ m!/dev/vc/[0-9]+!) 
	   && !$OPT_N) {
	if (&executable("consolechars")) {
	    system("consolechars -f iso05.f16 -m iso05.acm");
	}
	elsif (&executable("setfont")) {
	    system("setfont -f iso05.f16 -m iso05.acm");
	}
	else {
	    return 0;
	}
	exec("HAVE_CYR=1; export HAVE_CYR; ".
	       "$THIS -N -C $OPT");
	# We should never be here:
  	if ( &executable("cyr") && -f "${HOME}/.cyr_defaults") {
  	    exec('cyr');
  	} else {
	    exit;
	}
    }
    return 0;
}

sub havecyrfont() {
    my $i;
    open XSET, "xlsfonts|";
    while (defined($i=<XSET>)){
	if($i =~ /-iso8859-5$/ 
	   && $i =~ /^-[^-]*-fixed-medium-r-[^-]*-[^-]*-14-/) {
	    chomp($i);
	    close XSET;
	    return $i;
	}
    }
    close XSET;
    return 0;
}

sub executable($) {
    my($WHICH);
    $WHICH = '/usr/bin/which';
    if (system("$WHICH $_[0] >/dev/null")==0) {
	return 1;
    }
    return 0;
}

# ---------------------------------------------------
# initialize()
# ---------------------------------------------------
sub initialize() {

    my ($ss, $CYR_ENC, $XKBD, $CYR_KBD, $ENC, $KBD_OPTION, $CYR_OPTION, $HOME);

    $HOME = $ENV{HOME};

    $MAINDIR=$0;
    $MAINDIR =~ s+/[^/]*$++g;
    $MAINDIR .= "/..";
    $Sub::MAINDIR = $MAINDIR;

    $CYR_ENC = &choose_encoding();
 
    if ($CYR_ENC eq "CP1251") {
	$ENC = "cp1251";
	$CYR_ENC_GLIBC = $CYR_ENC;
	$FONTSET = "microsoft-cp1251";
    }
    if ($CYR_ENC eq "ISO8859-5") {
	$ENC = "iso-8859-5";
	$CYR_ENC_GLIBC = "ISO-8859-5";
	$FONTSET = "iso8859-5";
    }
    if ($CYR_ENC eq "KOI8-R") {
	$ENC = "koi8-r";
	$CYR_ENC_GLIBC = $CYR_ENC;
	$FONTSET = "koi8-r";
    }
    if ($CYR_ENC eq "KOI8-U") {
	$ENC = "koi8-u";
	$CYR_ENC_GLIBC = $CYR_ENC;
	$FONTSET = "koi8-u";
    }
    if ($CYR_ENC eq "ISO8859-2") {
	$ENC = "iso-8859-2";
	$CYR_ENC_GLIBC = "ISO-8859-2";
	$FONTSET = "iso8859-2";
    }

    $Sub::CYR_ENC = $CYR_ENC;

    $Sub::DOS_ENC = &dos_enc($CYR_ENC);

    $Sub::LOCALE = &locale($CYR_ENC);

    $Sub::LANGUAGE_PO = &language_po($CYR_ENC);

    $Sub::MUTT_ENCODING = &mutt_encoding();

    $Sub::MAIL_ENCODING = &mail_encoding($CYR_ENC);

    $Sub::FONTSET = $FONTSET;

    &now_we_will_configure_kbd($CYR_ENC);

    ($XKBD, $CYR_KBD) = &choose_keyboard($CYR_ENC);
    $Sub::CYR_KBD = $CYR_KBD;
    $Sub::XKBD = $XKBD;

    $ss = &grp_toggle($CYR_ENC);
    if ($ss == 1) {
	$CYR_OPTION = "toggle";
    }
    if ($ss == 2) {
	$CYR_OPTION = "shift_toggle";
    }
    if ($ss == 3) {
	$CYR_OPTION = "ctrl_shift_toggle";
    }
    if ($ss == 4) {
	$CYR_OPTION = "ctrl_alt_toggle";
    }
    if ($ss == 5) {
	$CYR_OPTION = "alt_shift_toggle";
    }
    if ($ss == 6) {
	$CYR_OPTION = "caps_toggle";
    }
    if ($ss == 7) {
	$CYR_OPTION = "menu_toggle";
    }
    if ($ss == 8) {
	$CYR_OPTION = "lwin_toggle";
    }
    if ($ss == 9) {
	$CYR_OPTION = "rwin_toggle";
    }
    if ($ss == 10) {
	$CYR_OPTION = "";
    }
    if ($CYR_OPTION ne "") {
	$KBD_OPTION = "grp:$CYR_OPTION";
    }

    $ss = &grp_switch();
    if ($ss == 1) {
	$KBD_OPTION = "${KBD_OPTION} grp:switch";
    }
    if ($ss == 2) {
	$KBD_OPTION = "${KBD_OPTION} grp:menu";
    }
    if ($ss == 3) {
	$KBD_OPTION = "${KBD_OPTION} grp:win_switch";
    }
    if ($ss == 4) {
	$KBD_OPTION = "${KBD_OPTION} grp:lwin_switch";
    }
    if ($ss == 5) {
	$KBD_OPTION = "${KBD_OPTION} grp:rwin_switch";
    }

    $ss=&lv3_switch();
    if ($ss == 1) {
	$KBD_OPTION = "${KBD_OPTION} lv3:switch";
    }
    if ($ss == 2) {
	$KBD_OPTION = "${KBD_OPTION} lv3:menu_switch";
    }
    if ($ss == 3) {
	$KBD_OPTION = "${KBD_OPTION} lv3:win_switch";
    }
    if ($ss == 4) {
	$KBD_OPTION = "${KBD_OPTION} lv3:lwin_switch";
    }
    if ($ss == 5) {
	$KBD_OPTION = "${KBD_OPTION} lv3:rwin_switch";
    }
    $Sub::CYR_OPTION = $CYR_OPTION;
    $Sub::KBD_OPTION = $KBD_OPTION;


    # ---------- record the preferences in ~/.xcyrillic ----------
    open XCYRILLIC, ">$ENV{HOME}/.xcyrillic";
    print XCYRILLIC "#!/bin/bash\n";
    print XCYRILLIC "\n";
    print XCYRILLIC "# A script to setup your language in X Window\n";
    print XCYRILLIC "\n";
    print XCYRILLIC "PATH=${MAINDIR}/bin:" . '${PATH}' . "\n";
    print XCYRILLIC "export PATH\n";
    print XCYRILLIC "# Setup the locale\n";
    print XCYRILLIC "unset LC_ALL\n";
    print XCYRILLIC "LANG=" . &locale($CYR_ENC) . "\n";
    print XCYRILLIC "LANGUAGE=" . &language_po($CYR_ENC) . "\n";
    print XCYRILLIC "export LANG LANGUAGE\n";
    print XCYRILLIC "\n";
    if (-x "${MAINDIR}/bin/xcyr") {
	print XCYRILLIC "if which xcyr >/dev/null 2>&1; then\n";
	print XCYRILLIC "# Setup fonts and keyboard\n";
	print XCYRILLIC "    xcyr -e ${ENC} ${XKBD} ${KBD_OPTION}\n";
	print XCYRILLIC "fi\n";
    } else {
	print XCYRILLIC "# Setup the keyboard\n";
	print XCYRILLIC "setxkbmap -model pc102 ${XKBD} ${KBD_OPTION}\n";
    }
    print XCYRILLIC <<'EOF';

# NLS for old motif applications
test -d /usr/X11R6/lib/X11/nls &&
    { XNLSPATH=/usr/X11R6/lib/X11/nls; export XNLSPATH; }

# Read the user resources database
test -f ~/.Xresources &&
    xrdb -merge ~/.Xresources

EOF
    close XCYRILLIC;
    chmod 0755,  "$ENV{HOME}/.xcyrillic";
    # ---------- add required packages ----------
    &Sub::addlist("locale-cyrillic");
    &Sub::addlist("console-cyrillic");
    if (&Sub::isinstalled("xserver-.*")
	|| &Sub::isinstalled("xbase-clients")) {
	&Sub::addlist("x-cyrillic");
	&Sub::addlist("xfonts-bolkhov-iso");
	&Sub::addlist("xfonts-cronyx-iso");
	if ($CYR_ENC eq "CP1251") {
	    &Sub::addlist("xfonts-cronyx-cp1251");
	    &Sub::addlist("xfonts-bolkhov-cp1251");
	}
#  	if ($CYR_ENC eq "ISO8859-5") {
#  	    &Sub::addlist("xfonts-cronyx-iso");
#  	    &Sub::addlist("xfonts-bolkhov-iso");
#  	}
	if ($CYR_ENC eq "KOI8-R") {
	    &Sub::addlist("xfonts-cronyx-koi8r");
	    &Sub::addlist("xfonts-bolkhov-koi8r");
	}
	if ($CYR_ENC eq "KOI8-U") {
	    &Sub::addlist("xfonts-cronyx-koi8u");
	    &Sub::addlist("xfonts-bolkhov-koi8u");
	}
    }
    return 0;
}

# ---------------------------------------------------
# sourceset2displayset()
# ---------------------------------------------------
sub sourceset2displayset ($)
{
	return $_[0];
}

# ---------------------------------------------------
# analcode()
# ---------------------------------------------------
sub analcode($)
{
	return 0;
}

# ---------------------------------------------------
# convcode()
# ---------------------------------------------------
sub convcode($$)
{
    return $_[0];
}

# ---------------------------------------------------
# Language specific subroutines
# ---------------------------------------------------
    
sub terminal_name() {
    return "Bulgarian Language Setup";
}

sub choose_encoding() {
    my $ss;
    $ss=&Sub::select("
Please choose your working encoding:
    1 = CP1251 (standard in Bulgaria, used also by MS Windows)
    2 = ISO-8859-5 (international Cyrillic encoding)
    3 = KOI8-R (Russian encoding for Unix)
    4 = KOI8-U (Ukrainian variant of KOI8-R)
", "
,  ,    :
    1 = CP1251 (  ,    MS Windows)
    2 = ISO-8859-5 (   )
    3 = KOI8-R (   )
    4 = KOI8-U (   KOI8-R)
", 4, 1);
    if ($ss == 1) { return "CP1251"; }
    if ($ss == 2) { return "ISO8859-5"; }
    if ($ss == 3) { return "KOI8-R"; }
    if ($ss == 4) { return "KOI8-U"; }
}

sub dos_enc(&) { 
    return "bulgarian-mik";
}

sub locale(&) { 
    my $locale = "bg_BG";
    my $encoding = "CP1251";
    my $variant = "";
    if ( $encoding eq $_[0] ) {
	return $locale . $variant;
    } else {
	return $locale . "." . $_[0] . $variant;
    }
}

sub language_po(&) { 
    return "bg,mk";
}

sub mutt_encoding() { 
    return "us-ascii:windows-1251:iso-8859-1:utf-8";
}

sub mail_encoding(&) { 
    return "CP1251";
}

sub now_we_will_configure_kbd(&) { 
    &Sub::disp("
For adjusting Cyrillic on console please use the command cyr.
Now we will try to configure the keyboard.
", "
        cyr.
      .
");
}

sub choose_keyboard() {
    my $ss;     
    $ss=&Sub::select("
What is your preferred keyboard layout:
    1 = BDS
    2 = phonetic
", "
     :
    1 = 
    2 = 
", 2, 1);
    if ($ss == 1) { return ("bg bds_enhanced", "bg_bds"); }
    if ($ss == 2) { return ("bg phonetic_enhanced", "bg_phon"); }                
}

sub grp_toggle() {    
    return &Sub::select("
How you will toggle between Cyrillic and Latin letters:
    1  = Right Alt
    2  = Left Shift + Right Shift (Right Shift on console)
    3  = Control + Shift
    4  = Control + Alt
    5  = Alt + Shift
    6  = Caps Lock (use Shift+CapsLock for CapsLock toggle)
    7  = Menu key
    8  = Left Windows logo key
    9  = Right Windows logo key
    10 = No toggling between Cyrillic and Latin
", "
      :
    1  =  Alt
    2  =  Shift +  Shift
    3  = Control + Shift
    4  = Control + Alt
    5  = Alt + Shift
    6  = Caps Lock (Shift+CapsLock   Caps Lock)
    7  =  Menu
    8  =      Windows
    9  =      Windows
    10 =      
", 10, 1);
}

sub grp_switch() {    
    return &Sub::select("
How you will switch temporary between Cyrillic and Latin letters:
    1 = Right Alt
    2 = Menu key
    3 = Left and Right Windows logo keys
    4 = Left Windows logo key
    5 = Right Windows logo key
    6 = No temporary switching between Cyrillic and Latin
", "
       :
    1 =  Alt
    2 =  Menu
    3 =        Windows
    4 =      Windows
    5 =      Windows
    6 =         
", 6, 6);
}

sub lv3_switch() {    
    return &Sub::select("
How you will choose publishing symbols:
    1 = Right Control
    2 = Menu key
    3 = Left and Right Windows logo keys
    4 = Left Windows logo key
    5 = Right Windows logo key
    6 = Publishing symbols are not needed
", "
      . :
    1 =  Control
    2 =  Menu
    3 =        Windows
    4 =      Windows
    5 =      Windows
    6 =     
", 6, 1);
}

# ---------------------------------------------------
# %messages
# ---------------------------------------------------


%messages = (
	     
# msgid
  "\nPush [Enter] key to End.\n" =>
# msgstr1 (in native language but in ASCII)
  "\nPush [Enter] key to End.\n\000".
# msgstr2 (in native language and in native character set: for
# example ISO-8859-1)
  "\n <Enter>  .\n" ,

# msgid
  "Now obtaining package list...\n" =>
# msgstr1 (in ASCII)
  "Now obtaining package list...\n\000".
# msgstr2 (in Native Character Set)
  ", ...\n" ,

# msgid
  "Do setting? " =>
# msgstr1 (in ASCII)
  "Do this setting? \000".
# msgstr2 (in Native Character Set)
  "     ? " ,

# msgid
  "Setting is not done.\n" =>
# msgstr1 (ASCII)
  "Setting is not done.\n\000".
# msgstr2 (in Native Character Set)
  "   .\n" ,

# msgid
  "Do setting...\n" =>
# msgstr1 (ASCII)
  "Do setting...\n\000".
# msgstr2 (in Native Character Set)
  "  ...\n" ,

# msgid
  "Cannot read \"%s\".\n" =>
# msgstr1 (ASCII)
  "Cannot read \"%s\".\n\000".
# msgstr2 (in Native Character Set)
  "     \"%s\".\n" ,

# msgid
  "Making a new file \"%s\"...\n" =>
# msgstr1 (ASCII)
  "Making a new file \"%s\"...\n\000".
# msgstr2 (in Native Character Set)
  "    \"%s\"...\n" ,

# msgid
  "Cannot open \"%s\".\n" =>
# msgstr1 (ASCII)
  "Cannot open \"%s\".\n\000".
# msgstr2 (in Native Character Set)
  "      \"%s\".\n" ,

# msgid
  "Cannot write to \"%s\".\n" =>
# msgstr1 (ASCII)
  "Cannot write to \"%s\".\n\000".
# msgstr2 (in Native Character Set)
  "      \"%s\".\n" ,

# msgid
  "Cannot lock \"%s\".\n" =>
# msgstr1 (ASCII)
  "Cannot lock \"%s\".\n\000".
# msgstr2 (in Native Character Set)
  " \"%s\"        .\n" ,

# msgid
  "Cannot close \"%s\".\n" =>
# msgstr1 (ASCII)
  "Cannot close \"%s\".\n\000".
# msgstr2 (in Native Character Set)
  " \"%s\"     .\n" ,

# msgid
  "Install the following packages.\n" =>
# msgstr1 (ASCII)
  "Install the following packages:\n\000".
# msgstr2 (in Native Character Set)
  "     :\n" ,

# msgid
  "   Setting is now done.  To activate these settings,\n".
  "logout and login.\n".
  "   Read each dotfile and confirm the modification.\n".
  "If you don't like the setting, modify directly or\n".
  "add overriding setting after 'bulgarian-env end' line.\n".
  "   Read /usr/share/doc/bulgarian-env/README.* for detail.\n" =>
# msgstr1 (ASCII)
  "   Setting is now done.  To activate these settings,\n".
  "logout and login.\n".
  "   Read each dotfile and confirm the modification.\n".
  "If you don't like the setting, modify directly or\n".
  "add overriding setting after 'bulgarian-env end' line.\n".
  "   Read /usr/share/doc/bulgarian-env/README.* for detail.\n\000".
# msgstr2 (in Native Character Set)
  "          .    \n".
  "      .\n".
  "       (    )\n".
  "  ,    .      ,\n".
  "          \n".
  "\"bulgarian-env end\".\n".
  "     /usr/share/doc/bulgarian-env/README.*  \n".
  ".\n",

# msgid
  "Usage: set-bulgarian-env [options]\n".
  "  -l language : Specify language (otherwise choose from menu)\n".
  "  -h          : This help message\n".
  "  -v          : 'verbose mode'\n".
  "  -s          : Display list of supported languages and exit\n".
  "  -r          : Remove all settings\n".
  "  -N          : Never fork another set-bulgarian-env (for internal use)\n".
  "  -c          : Don't use native character set (for internal use)\n".
  "  -C          : Use native character set (for internal use)\n".
  "  -E          : Setting for /etc/environ directory (root user only)\n" =>
# msgstr1 (ASCII)
  "Usage: set-bulgarian-env [options]\n".
  "  -l language : Specify language (otherwise choose from menu)\n".
  "  -h          : This help message\n".
  "  -v          : 'verbose mode'\n".
  "  -s          : Display list of supported languages and exit\n".
  "  -r          : Remove all settings\n".
  "  -N          : Never fork another set-bulgarian-env (for internal use)\n".
  "  -c          : Don't use native character set (for internal use)\n".
  "  -C          : Use native character set (for internal use)\n".
  "  -E          : Setting for /etc/environ directory (root user only)\n\000".
# msgstr2 (in Native Character Set)
  ": set-bulgarian-env []\n".
  "  -l      (     )\n".
  "  -h          \n".
  "  -v            \n".
  "  -s            \n".
  "  -r             \n".
  "  -N             set-bulgarian-env (  )\n".
  "  -c               (  )\n".
  "  -C              (  )\n".
  "  -E             /etc/skel (  root)\n"

);

$yes_upper = "Y";
$yes_lower = "y";
$no_upper = "N";
$no_lower = "n";
       
